/****************************************************************************
#	 	Gideo: A Small (spca5x) Video Capture utility                       #
# 		Copyright (C) 2004 David Truman	                                    #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#                                                                           #
****************************************************************************/



#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "globals.h"

unsigned char message[2];

gboolean showing;



void
on_spca1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_vga1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  message[0] = SIZE;
  message[1] = VGA;
  LASTRES = message[1];
  write (fd[1], message, 2);
}


void
on_pal1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  message[0] = SIZE;
  message[1] = PAL;
  LASTRES = message[1];
  write (fd[1], message, 2);
}


void
on_sif1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  message[0] = SIZE;
  message[1] = SIF;
  LASTRES = message[1];
  write (fd[1], message, 2);
}


void
on_cif1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  message[0] = SIZE;
  message[1] = CIF;
  LASTRES = message[1];
  write (fd[1], message, 2);
}


void
on_qpal1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  message[0] = SIZE;
  message[1] = QPAL;
  LASTRES = message[1];
  write (fd[1], message, 2);
}


void
on_qsif1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  message[0] = SIZE;
  message[1] = QSIF;
  LASTRES = message[1];
  write (fd[1], message, 2);
}


void
on_qcif1_activate                      (GtkMenuItem     *menuitem,
                                       gpointer         user_data)
{
  message[0] = SIZE;
  message[1] = QCIF;
  LASTRES = message[1];
  write (fd[1], message, 2); 
}


void
on_gui1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_jpg1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   if ((LASTRES != CIF) && (LASTRES != VGA))
   {setJPGres();}

	if (isjpg != TRUE){
     isjpg = TRUE;	
	 hidemenus(isjpg);}

  
	 
  message[0] = PALETTE;
  message[1] = JPG;
  write (fd[1], message, 2); 
 	
}


void
on_yuv1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if (isjpg != FALSE){
     isjpg = FALSE;	
	 hidemenus(isjpg);}
  
  message[0] = PALETTE;
  message[1] = YUV;
  write (fd[1], message, 2);		 
}


void
on_r1_activate                         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if (isjpg != FALSE){
     isjpg = FALSE;	
	 hidemenus(isjpg);}
  
  message[0] = PALETTE;
  message[1] = R16;
  write (fd[1], message, 2);		  
}


void
on_r2_activate                         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if (isjpg != FALSE){
     isjpg = FALSE;	
	 hidemenus(isjpg);}
	 
  message[0] = PALETTE;
  message[1] = R24;
  write (fd[1], message, 2);		 
}


void
on_r3_activate                         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   if (isjpg != FALSE){
     isjpg = FALSE;	
	 hidemenus(isjpg);}	

  message[0] = PALETTE;
  message[1] = R32;
  write (fd[1], message, 2);	 	 
}

gboolean
on_window1_delete_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{ 
  message[0] = QUIT;
  message[1] = TRUE;
  write (fd[1], message, 2);	
  gtk_main_quit();
  return FALSE;
}


gboolean
on_window1_destroy_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  message[0] = QUIT;
  message[1] = TRUE;
  write (fd[1], message, 2);	
  gtk_main_quit();
  return FALSE;
}


void
on_optionmenu2_changed                 (GtkOptionMenu   *optionmenu,
                                        gpointer         user_data)
{}


void
on_optionmenu1_changed                 (GtkOptionMenu   *optionmenu,
                                        gpointer         user_data)
{}


void
on_hscale1_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
  message[0] = BRIGHT;
  message[1] = (char) gtk_range_get_value(range);
  write (fd[1], message, 2);
}


void
on_hscale2_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
  message[0] = CONTRAST;
  message[1] = (char) gtk_range_get_value(range);
  write (fd[1], message, 2);
}


void
on_hscale3_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
  message[0] = COLOR;
  message[1] = (char) gtk_range_get_value(range);
  write (fd[1], message, 2);
}


void
on_togglebutton2_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  message[0] = AVI;
  message[1] = gtk_toggle_button_get_active (togglebutton);
  write (fd[1], message, 2);
}


void
on_togglebutton1_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{  
  message[0] = PHOTO;
  message[1] =  gtk_toggle_button_get_active (togglebutton);
  if (message[1])
	write (fd[1], message, 2);	
 
  gtk_toggle_button_set_active (togglebutton,FALSE);	
}


void
on_togglebutton3_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  message[0] = PAUSE;
  message[1] = gtk_toggle_button_get_active (togglebutton);
  write (fd[1], message, 2);	
}


void
on_togglebutton4_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  message[0] = FLIPRGB;
  message[1] = gtk_toggle_button_get_active (togglebutton);
  write (fd[1], message, 2);
}


void
on_togglebutton5_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
    //g_print("Sound Controler Not Implemented Yet...\n");
  message[0] = QUIT;
  message[1] = TRUE;
  write (fd[1], message, 2);	
  gtk_toggle_button_set_active (togglebutton,FALSE);
  gtk_main_quit();
  
}
